/**
 * Created by Artek on 16.10.2015.
 */

function Q3iComplexifyViewModel(config) {

    this.config = config || {};
    this.firstFieldJQ = null;
    this.secondFieldJQ = null;

}

Q3iComplexifyViewModel.prototype.initComplexify = function(passjQueryElement, barjQueryElement, totalBarWidth, validCallback, notValidCallback) {
    var self = this;
    totalBarWidth = totalBarWidth || 370;

    // Use the complexify plugin on the first password field
    passjQueryElement.complexify(
        this.config,
        function(valid, complexity){

            var barWidth = (totalBarWidth/100) * complexity;
            barjQueryElement.width(barWidth);

            if(valid){
                validCallback(complexity);
            } else {
                notValidCallback(complexity);
            }

        }
    );

};

Q3iComplexifyViewModel.prototype.complexify = function(passwordFieldJQ, passwordRepeatFieldJQ, totalBarWidth) {
    var self = this;
    this.firstFieldJQ = passwordFieldJQ;
    this.secondFieldJQ = passwordRepeatFieldJQ;

    //self.setFieldValid(self.firstFieldJQ, false);
    self.passwordSecondEnable(false);
    self.injectIndicatorHtml(totalBarWidth);
    self.initComplexify(
        self.firstFieldJQ,
        $('.pass-check-bar'),
        totalBarWidth,
        function valid(complexity) {
            self.setFieldValid(self.firstFieldJQ, true);
            self.passwordSecondEnable(true);
        },
        function notValid(complexity) {
            self.firstFieldJQ.removeClass('password-valid');
            self.firstFieldJQ.toggleClass('password-invalid', (complexity < 1));
            self.passwordSecondEnable(false);
        }
    );
};

Q3iComplexifyViewModel.prototype.passwordSecondEnable = function(flag) {
    var self = this;

    self.secondFieldJQ.prop('disabled', !flag);

    self.secondFieldJQ.bind("propertychange change click keyup input paste", function(event){
        // If value has changed...
        if (self.secondFieldJQ.val() > '' && self.firstFieldJQ.val() == self.secondFieldJQ.val()) {
            self.setFieldValid(self.secondFieldJQ, true);
        } else {
            self.setFieldValid(self.secondFieldJQ, false);
        }
    });
};

Q3iComplexifyViewModel.prototype.setFieldValid = function(jQueryElement, flag){
    if (flag) {
        jQueryElement.removeClass('password-invalid');
        jQueryElement.addClass('password-valid');
    } else {
        jQueryElement.removeClass('password-valid');
        jQueryElement.addClass('password-invalid');
    }
};

Q3iComplexifyViewModel.prototype.injectIndicatorHtml = function(indicatorBarWidth) {
    var self = this;
    var indicatorElementHtml = '<div id="pass-check-bar" class="pass-check-bar" style="width: 0px;"><div class="pass-check-bar_bg" style="width: ' + indicatorBarWidth + 'px"></div></div>';
    if ($('#Q3I_COMPLEXIFY_BAR').length) {
        $('#Q3I_COMPLEXIFY_BAR').replaceWith(indicatorElementHtml);
    } else {
        self.firstFieldJQ.after(indicatorElementHtml);
    }

    var inputHint = '<p>' + Q3iComplexifyConfig.inputHint || 'Please type in a complex password to enable the password repeat field.' + '</p>';
    if ($('#Q3I_COMPLEXIFY_INFO').length) {
        $('#Q3I_COMPLEXIFY_INFO').html(inputHint);
    } else {
        $('#pass-check-bar').before(inputHint);
    }
};
